<?php
/*
Plugin Name: WP Config Editor
Description: Plugin untuk menambah atau mengedit kode di wp-config.php.
Version: 1.0
Author: BardPress
*/

// Buat menu di admin dashboard
add_action('admin_menu', 'wp_config_editor_menu');
function wp_config_editor_menu() {
    add_options_page('WP Config Editor', 'WP Config Editor', 'manage_options', 'wp-config-editor', 'wp_config_editor_page');
}

// Halaman pengaturan plugin
function wp_config_editor_page() {
    ?>
    <div class="wrap">
        <h1>WP Config Editor</h1>
        <form method="post" action="options.php">
            <?php
            settings_fields('wp_config_editor_options_group');
            do_settings_sections('wp-config-editor');
            submit_button();
            ?>
        </form>
    </div>
    <?php
}

// Inisialisasi pengaturan
add_action('admin_init', 'wp_config_editor_settings');
function wp_config_editor_settings() {
    register_setting('wp_config_editor_options_group', 'wp_api_key');
    add_settings_section('wp_config_editor_section', 'Pengaturan WP Config Editor', null, 'wp-config-editor');
    add_settings_field('wp_api_key', 'WP API Key', 'wp_config_editor_wp_api_key_callback', 'wp-config-editor', 'wp_config_editor_section');
}

// Callback untuk input WP API Key
function wp_config_editor_wp_api_key_callback() {
    $wp_api_key = get_option('wp_api_key');
    echo '<input type="text" name="wp_api_key" value="' . esc_attr($wp_api_key) . '" />';
}

// Fungsi untuk menambah atau mengedit kode di wp-config.php
function wp_config_editor_update_wp_config() {
    if (!current_user_can('manage_options')) {
        return;
    }

    $wp_api_key = get_option('wp_api_key');
    $config_file = ABSPATH . 'wp-config.php';
    $config_content = file_get_contents($config_file);

    // Define strings
    $define_wp_rest_api_enabled = "define('WP_REST_API_ENABLED', true);";
    $define_wp_api_key = "define('WP_API_KEY', '" . $wp_api_key . "');";

    // Check and append or update WP_REST_API_ENABLED
    if (strpos($config_content, "define('WP_REST_API_ENABLED'") === false) {
        $config_content .= "\n" . $define_wp_rest_api_enabled;
    }

    // Check and append or update WP_API_KEY
    if (strpos($config_content, "define('WP_API_KEY'") === false) {
        $config_content .= "\n" . $define_wp_api_key;
    } else {
        $config_content = preg_replace("/define\('WP_API_KEY'.*\);/", $define_wp_api_key, $config_content);
    }

    file_put_contents($config_file, $config_content);
}
add_action('update_option_wp_api_key', 'wp_config_editor_update_wp_config');
add_action('add_option_wp_api_key', 'wp_config_editor_update_wp_config');
